## libsfml 3.0.0+dfsg

=== debian/changelog ===
libsfml (3.0.0+dfsg-1) experimental; urgency=medium

  * New upstream version.

  * d/patches: Drop patches applied upstream.

 -- James Cowgill <jcowgill@debian.org>  Thu, 26 Dec 2024 12:40:27 +0000

libsfml (3.0.0~rc2+dfsg-1) experimental; urgency=medium

  * New upstream release candidate.

  * d/copyright: Updates for -rc2.
  * d/patches:
    - Refresh patches.
    - Add patches to fix big-endian issues.
  * d/libsfml-doc.links: Add missing tuffy.ttf symlink.
  * d/rules: Only build docs in arch-indep builds.
  * d/tests:
    - Rename existing tests to "smoke-".
    - Add a test runs the upstream testsuite.

 -- James Cowgill <jcowgill@debian.org>  Sun, 08 Dec 2024 12:33:56 +0000

libsfml (3.0.0~rc1+dfsg-1) experimental; urgency=medium

  * New upstream release candidate.

  * d/control:
    - Change library package suffix to 3.0
    - Build depend on catch2, miniaudio and xi.
  * d/copyright:
    - Update list of excluded libraries and exclude the bundled Gradle
      wrapper JAR.
    - Updates for 3.0.
  * d/libsfml-doc.README.Debian: Remove.
  * d/libsfml-doc.docs: Install the upstream readme and migration guide.
  * d/libsfml-doc.links: Add more tuffy.ttf links.
  * d/patches:
    - Refresh and drop patches applied upstream
    - Add patch to use the system Catch2 instead of downloading it.
    - Add patch to skip sf::IpAddress tests that use the network.
  * d/rules:
    - Explicitly enable BUILD_SHARED_LIBS.
    - Disable hardware tests.
    - Remove android example.
  * d/watch:
    - Handle upstream rc version numbering.
    - Simplify options.
  * d/tests: Update to the new SFML API.

 -- James Cowgill <jcowgill@debian.org>  Sat, 30 Nov 2024 17:06:17 +0000
