=== debian/tests/control ===
Tests: smoke-build
Depends: g++, libsfml-dev, pkg-config
Restrictions: superficial

Tests: smoke-cmake
Depends: cmake, g++, libsfml-dev, make
Restrictions: superficial

Tests: upstream-tests
Depends: cmake, g++, libcatch2-dev, libsfml-dev, make, xserver-xorg-core, xserver-xorg-video-dummy
Restrictions: allow-stderr breaks-testbed
