=== debian/changelog ===
libsfml (3.0.1+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- James Cowgill <jcowgill@debian.org>  Wed, 03 Sep 2025 19:15:01 +0100

libsfml (3.0.1+dfsg-1) experimental; urgency=medium

  * New upstream version.

  * d/patches:
    - Refresh patches.
    - Use upstream version of 07_skip_IpAddress_tests.
    - Add patch to fix upstream pkg-config bug in 3.0.1.
    - Add patch to fix SFMLConfig.in with old CMake policy.
  * d/tests:
    - Set VERSION_IS_RELEASE in upstream-tests.
    - Disable CMake deprecation warnings.
    - Add smoke-cmake-min to test with old CMake policies.

 -- James Cowgill <jcowgill@debian.org>  Sat, 24 May 2025 17:50:57 +0100
