=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: libsfml
 Section: libs
-Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  James Cowgill <jcowgill@debian.org>
@@ -14,7 +13,6 @@
  libopenal-dev,
  libstb-dev,
  libudev-dev [linux-any],
- libusbhid-dev [kfreebsd-any],
  libvorbis-dev,
  libvulkan-dev,
  libx11-dev,
@@ -23,8 +21,7 @@
  libxrandr-dev,
  pkgconf,
 Build-Depends-Indep: doxygen
-Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://www.sfml-dev.org/
 Vcs-Git: https://salsa.debian.org/games-team/libsfml.git
 Vcs-Browser: https://salsa.debian.org/games-team/libsfml
