=== debian/changelog ===
libsfml (3.0.2+dfsg-1) unstable; urgency=medium

  * New upstream version.

  * d/control: Bump standards version.
  * d/copyright: Update date.
  * d/patches: Refresh and drop patches applied upstream.

 -- James Cowgill <jcowgill@debian.org>  Fri, 19 Sep 2025 21:16:23 +0100
