=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DSFML_BUILD_DOC=$(if $(findstring libsfml-doc,$(shell dh_listpackages)),ON,OFF) \
		-DSFML_BUILD_EXAMPLES=ON \
		-DSFML_BUILD_TEST_SUITE=ON \
		-DSFML_RUN_AUDIO_DEVICE_TESTS=OFF \
		-DSFML_RUN_DISPLAY_TESTS=OFF

execute_after_dh_auto_build-indep:
	dh_auto_build -- doc

override_dh_auto_test-indep:

override_dh_installexamples:
	dh_installexamples -X.gitignore -Xandroid

override_dh_compress:
	dh_compress -XSFML.tag
