=== debian/tests/control ===
--- 
+++ 
@@ -6,6 +6,10 @@
 Depends: cmake, g++, libsfml-dev, make
 Restrictions: superficial
 
+Tests: smoke-cmake-min
+Depends: cmake, g++, libsfml-dev, make
+Restrictions: superficial
+
 Tests: upstream-tests
 Depends: cmake, g++, libcatch2-dev, libsfml-dev, make, xserver-xorg-core, xserver-xorg-video-dummy
 Restrictions: allow-stderr breaks-testbed
