=== debian/watch ===
# See uscan(1) for format
version=4

# From GitHub
opts=uversionmangle=s/-rc\./~rc/,dversionmangle=auto,repacksuffix=+dfsg \
  https://github.com/SFML/SFML/tags .*/v?(\d\S*)\.tar\.gz
